/**
 *
 * @license MIT License
 *
 * Copyright (c) 2024 lewis he
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * @file      GeneralPPMConstants.h
 * @author    Lewis He (lewishe@outlook.com)
 * @date      2024-10-29
 *
 */
#pragma once

#define POWERS_PPM_REG_00H                                   (0x00)
#define POWERS_PPM_REG_01H                                   (0x01)
#define POWERS_PPM_REG_02H                                   (0x02)
#define POWERS_PPM_REG_03H                                   (0x03)
#define POWERS_PPM_REG_04H                                   (0x04)
#define POWERS_PPM_REG_05H                                   (0x05)
#define POWERS_PPM_REG_06H                                   (0x06)
#define POWERS_PPM_REG_07H                                   (0x07)
#define POWERS_PPM_REG_08H                                   (0x08)
#define POWERS_PPM_REG_09H                                   (0x09)
#define POWERS_PPM_REG_0AH                                   (0x0A)
// Read only STATUS REG
#define POWERS_PPM_REG_0BH                                   (0x0B)
// Read only CHARGE IRQ REG
#define POWERS_PPM_REG_0CH                                   (0x0C)
// Absolute VINDPM Threshold
#define POWERS_PPM_REG_0DH                                   (0x0D)
// Read only BATTERY VOLTAGE
#define POWERS_PPM_REG_0EH                                   (0x0E)
// Read only SYSTEM VOLTAGE
#define POWERS_PPM_REG_0FH                                   (0x0F)
// Read only NTC PERCENTAGE
#define POWERS_PPM_REG_10H                                   (0x10)
// Read only VBUS VOLTAGE
#define POWERS_PPM_REG_11H                                   (0x11)
// Read only CHARGE CURRENT
#define POWERS_PPM_REG_12H                                   (0x12)
// Read only VINDPM/IINDPM STATUS/CURR LIMIT SETTING 
#define POWERS_PPM_REG_13H                                   (0x13)
// RESET REG
#define POWERS_PPM_REG_14H                                   (0x14)
















